#  Copyright 2021 Collate
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#  http://www.apache.org/licenses/LICENSE-2.0
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
from typing import Optional

from pydantic import BaseModel

from metadata.generated.schema.entity.policies.policy import Policy
from metadata.generated.schema.entity.data.location import Location


class OMetaPolicy(BaseModel):
    policy: Policy
    # A Lifecycle Policy may be associated with a specific Location such as S3 bucket.
    location: Optional[Location]
